/*
 *  (C) Copyright 2006 ZeXx86 (Admin@Infern0.tk)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */


#ifndef _BAN_H
#define _BAN_H 

/* Ban structure */
typedef struct ban_context {
	struct ban_context *next, *prev;

	char nick[DEFAULT_MAX_NICKLENGTH];
	char ip[16];
	unsigned long long bantime;
	unsigned long banlong;
}ban_t;

// create
extern unsigned short ban_add_bynick (user_t *u, char *data);
extern unsigned short ban_add_byip (user_t *u, char *data);
// delete
extern void ban_del (ban_t *ban);
extern ban_t *ban_add (char *data);
// find
extern unsigned long ban_find_bynick (char *nick);
extern unsigned long ban_find_byip (char *ip);
// init
extern int init_ban ();
// save
extern unsigned short ban_save ();

#endif
