/*
 *  (C) Copyright 2006 ZeXx86 (Admin@Infern0.tk)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */


#ifndef _CHATROOM_H
#define _CHATROOM_H

#include "defaults.h"
#include "proto.h"


/* Chatroom structure */
typedef struct chatroom_context {
  struct chatroom_context *next, *prev;

  char name[DEFAULT_MAX_NICKLENGTH];
  unsigned short name_len;
  char desc[193];
  int  minclass;
  char *myinfo;
  unsigned int myinfo_len;
} chatroom_t;

typedef struct {
	char *myinfos;
	unsigned long len;
	char *lists;
	unsigned int l;
} chatroom_public_t;


extern user_t user_list;
extern chatroom_t chatroom_list;

extern int init_chatroom ();
extern int chatroom_msghandler (user_t *u, char *data, unsigned int len, chatroom_t *room);
extern chatroom_t *chatroom_find (char *name);
extern int chatroom_save ();
extern int chatroom_load ();
extern int chatroom_rebuild ();

#endif
