/*
 *  (C) Copyright 2006 ZeXx86 (Admin@Infern0.tk)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */


#ifndef _COMMANDS_H
#define _COMMANDS_H

#include "user.h"
#include "defaults.h"

/* Command structure */
typedef bool (command_handler_t) (user_t *u, char *data);

typedef struct command_context {
  struct command_context *next, *prev;

  char name[32];
  char desc[64];
  int iclass;
  command_handler_t *handler;
} command_t;


/* registering commands */
extern int command_register (char *name, char *desc, command_handler_t *handler ,unsigned int iclass);
extern int command_unregister (char *name);
extern int command_parser (user_t *u,char *command, char *data, unsigned int len);
extern int init_commands ();
extern void cpu_init ();
extern unsigned int cpu_measure ();

#endif
