#ifndef _CONFIG_H
#define _CONFIG_H

#include <string.h>
#include "utils.h"

/* Deflood structure */
typedef struct {
	unsigned int mainchat;
	unsigned int pm;
	int mainchat_lock;
	int pm_lock;
} deflood_t;

/* Config structure */
typedef struct {
	char hubname[64];
	char hubdesc[80];
	char hubaddress[40];
	int port;
	char initstr[150];
	unsigned int initlen;
	char botname[128];
	unsigned int botname_len;
	char *motd;
	unsigned int motd_len;
	unsigned int userlimit;
	unsigned int pm_lenght;
	unsigned int chat_lenght;
	long long int autosave;		// interval of saving config (sec)
	long long int hublist_interval; // interval of saving config (sec)
	int search_interval[6];	// interval of search (sec)
	unsigned int minslots[6];
	unsigned long long int minshare[6];
	char *redirect[MAX_REDIRECTHOST];
	char *hublist_hosts;
	deflood_t deflood;
	unsigned long long rights[6];
	unsigned long bufferhard;
	unsigned long buffersoft;
} config_t;

/* Config context structure */
typedef struct config_context {
  struct config_context *next, *prev;

  char name[64];
  char desc[256];
  int type;
  char *value;
} config_elem_t;

extern int config_register (char *name, char *desc, int type, char *value);
extern char *config_get (char *name);
extern int config_set (char *name, char *value);
extern int init_config ();
extern int config_save (char *filename);
extern int config_load (char *filename);

#endif 
 
 
