/*
 *  (C) Copyright 2006 ZeXx86 (Admin@Infern0.tk)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */


#ifndef _DEFAULTS_H_
#define _DEFAULTS_H_

/********************************************************************\
|			      DEFINES				     |
\********************************************************************/


#define	  VERSION				"0.0.6.2"
#define   HUBSOFT				"LamaHub"

/* 		      PLATFORM SPEC.			*/
#ifdef __WIN32__
 #define   PLATFORM				"Windows"
#else
 #ifdef __FreeBSD__
  #define   PLATFORM				"FreeBSD"
 #endif
 #ifdef __NetBSD__
  #define   PLATFORM				"NetBSD"
 #endif
 #ifdef __OpenBSD__
  #define   PLATFORM				"OpenBSD"
 #endif
 #ifdef __zexos__
  #define   PLATFORM				"ZeX/OS"
 #endif
 #ifdef __linux__
  #define   PLATFORM				"Linux"
 #endif
 #ifdef __android__
  #define   PLATFORM				"Android"
 #endif
#endif

/*	  max. length of buffers		*/
#define   DEFAULT_MAX_NICKLENGTH		64
#define   DEFAULT_MAX_MYINFOLENGTH		192
#define   DEFAULT_MAX_DESCLENGTH		80
#define   DEFAULT_MAX_EMAILLENGTH		48
#define   DEFAULT_MAX_ADDRESSLENGTH		64

/*		pre-set times (sec)		*/
#define   DEFAULT_KICKTIME			120
#define   DEFAULT_BANTIME			3600
#define   DEFAULT_SEARCH_INTERVAL		32

/* socket function */
/*
	You can choose between socket function (Select, Poll or Send/Recv)
	Select is best way for hub to max. ~1000 clients
	Poll is'nt bad for many clients > 1000
	Send/Recv is very stable, good on everything (universal), but in more connections may have more prettend on cpu

	If you want use Poll comment line with "#define SELECT" - so add "//" ahead #define... and remove "//" from "//#define POLL"
	For Send/Recv comment lines with #define SELECT and #define POLL
*/
#define   SELECT				// stable, low cpu usage but only for max. 1024 conn.
//#define   POLL				// unstable, very low cpu usage, very fast, for many clients
//#define EPOLL					// testing, very low cpu usage, extra fast, very powerful, for thousands clients

/* zlib data compression */
//#define   ZPIPE

/* lua script language */
//#define	  LUA

/* receive buffer (bytes) */
#ifdef __zexos__
# define   BUFSIZE				1024
#else
# define   BUFSIZE				1024
#endif

#define   DEFAULT_SOCKET_RETTIME		1

/* kick message */
#define   DEFAULT_KICK_MESSAGE			"reason not found."

/* name of files */
#ifndef __android__
# define   DEFAULT_ACCOUNTSFILE			"accounts.conf"
# define   DEFAULT_HUBFILE			"hub.conf"
# define   DEFAULT_MOTDFILE			"motd.conf"
# define   DEFAULT_CHATROOMFILE			"chatroom.conf"
# define   DEFAULT_LUAFILE			"scripts.conf"
# define   DEFAULT_PLUGINFILE			"plugins.conf"
# define   DEFAULT_BANFILE			"ban.conf"
#else
#define   DEFAULT_ACCOUNTSFILE			"/sdcard/lamahub/accounts.conf"
#define   DEFAULT_HUBFILE			"/sdcard/lamahub/hub.conf"
#define   DEFAULT_MOTDFILE			"/sdcard/lamahub/motd.conf"
#define   DEFAULT_CHATROOMFILE			"/sdcard/lamahub/chatroom.conf"
#define	  DEFAULT_LUAFILE			"/sdcard/lamahub/scripts.conf"
#define	  DEFAULT_PLUGINFILE			"/sdcard/lamahub/plugins.conf"
#define	  DEFAULT_BANFILE			"/sdcard/lamahub/ban.conf"
#endif
/* debug mode */
//#define	  DEBUG					// only for developers

/* system defines */
#ifdef __WIN32__ 
 #define socklen_t				int
 #define usleep 				Sleep
#else
 #define   SOCKET				int
#endif
/********************************************************************/

typedef enum { false = 0, true = 1 } bool; /* boolean value */

#endif
