/*
 *  (C) Copyright 2006 ZeXx86 (Admin@Infern0.tk)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */


#ifndef _LUA_H
#define _LUA_H

#include "user.h"
#include "defaults.h"

/* lua events state */
enum {
	EVENT_NEWCLIENT,
	EVENT_USERCONNECTED,
	EVENT_GETNICKLIST,
	EVENT_LOCK,
	EVENT_SEARCH,
	EVENT_QUIT,
	EVENT_CHAT,
	EVENT_PM,
	EVENT_COMMAND,
	EVENT_OPCONNECTED,
	EVENT_TIMER,
	EVENT_CHATIN,
};

static const unsigned long LuaEventBits[] = {
    0x1,
    0x2,
    0x4,
    0x8,
    0x10,
    0x20,
    0x40,
    0x80,
    0x100,
    0x200,
    0x400,
    0x800
};

/* only if is allowed Lua support */
#ifdef LUA

typedef struct {
	unsigned long long sec;
	unsigned int interval;
	bool active;
} timer_lua_t;

/* externs */
extern int init_lua ();
extern int lua_list_load (char *file);
extern int lua_list_save (char *file);
extern int luascript_save ();
#endif
/* we want to use this function everytime */
extern int event_lua (user_t* u, char *data, unsigned long event, unsigned long len);
extern int event_lua_hub (user_t* u, unsigned long event);
extern int event_lua_sys (unsigned long event);
#endif 
