/*
 *  (C) Copyright 2006 ZeXx86 (Admin@Infern0.tk)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */



#include "ezlib.h"
#ifdef ZPIPE
#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <zlib.h>
#include "utils.h"

extern stats_t	stats;

/* report a zlib or i/o error */
void zerr(int ret)
{
    fputs("zpipe: ", stderr);
}

unsigned long zdef (char *data, unsigned long l, char *out, unsigned long len)
{
  z_stream stream;

  memcpy (out, "$ZOn|", 5);

  // init zlib struct
  stream.zalloc = Z_NULL;
  stream.zfree = Z_NULL;
  stream.data_type = Z_ASCII;

  memset (&stream, 0, sizeof (stream));
  deflateInit (&stream, Z_BEST_COMPRESSION);

  stream.next_in = (Bytef*) data;
  stream.avail_in = l;

  stream.next_out = (Bytef*) out + 5;
  stream.avail_out = len - 5;

  // compress
  if (deflate (&stream, Z_FINISH) != Z_STREAM_END) {
    deflateEnd (&stream);
    return 0;
  }

  // cleanup zlib
   deflateEnd (&stream);

  if (stats.buf_zpipe_count > 16) {
	stats.buf_zpipe_count	= 0;
        stats.buf_zpipe_compression_avg = 0;
  }

  stats.buf_zpipe_compression  =  (stream.total_out %l) / 100;
  stats.buf_zpipe_compression_avg += stats.buf_zpipe_compression;

  stats.buf_zpipe_count ++;

  unsigned long len2 = stream.total_out + 5;

  return len2;
}

#endif
