--| googlebot.lua version 0.3 07-12-2005 |--
--| |--
--| GoogleBot |--
--| Author: ZeroSleep |--
--| e-mail: more (dot) caffiene (at) gmail (dot) com |--
--| |--
--| Bug checked by: Hellkeepa |--
--| hellkeeper_1 (at) hotmail (dot) com |--
--| |--
--| (c) 2005. All Rights Reserved |--
--| GNU GPL License |--
--| |--
--| Generates a set of 4 Google URL's to aid a user in |--
--| finding files of a particular type with keywords |--
--| |--
--| usage: |--
--| #google <file_type> <keyword(s)> |--
--| |--
--| i.e. |--
--| #google mp3 radiohead |--
--| #google avi star+wars+sith |--
--| |--
--| modify by ZeXx86 for hubsoft LamaHub

-- Command for user-help, change it if you want to.
set_cmd_help = "#gbhelp";

-- Use existing bot? "true" is yes, and "false" is no.
use_existing_bot = false;

-- The name for the bot, set to existing bot if above is "true".
set_bot_name = "GoogleBot"

-- Replace with your e-mail address.
set_bot_email = "gmail.com";

-- Change this too, if you want; Bot-description.
set_bot_desc = "Write "..set_cmd_help.." in main for commands.";


-- Check if script should add a new bot.
if (not use_existing_bot or use_existing_bot == 0) then
-- Add new bot.
BotAdd( set_bot_name, set_bot_desc, "BOT", set_bot_email, 4, 0);
end;

-- Executed on all user commands ("#" commands).
function EventChat(nick, data)
local message, filetype, searchstring;
if (string.find(data, "#google", 1, 1)) then
_,_,filetype,searchstring = string.find(data, "#google%s(%S+)%s(%S+)|")
message = "Here are some search URL's for you to try:\n".."If the first search doesn't return the results you are looking for, try another.\n\n".."1.\n".."http://www.google.com/search?hl=en&q=intitle%3Aindex.of+%2B+%22"..filetype.."%22+%2B+%22"..searchstring.."%22+-htm+-html+-php+-asp&btnG=Google+Search\n".."2.\n".."http://www.google.com/search?hl=en&q=%22index+of%22+%2B+intitle%3A"..filetype.."+%2B+%22"..searchstring.."%22+-htm+-html+-php+-asp&btnG=Google+Search\n".."3.\n".."http://www.google.com/search?hl=en&lr=&q=inurl%3Aandromeda.php+%2B+%22"..filetype.."%22+%2B+%22"..searchstring.."%22&btnG=Search\n".."4.\n".."http://www.google.com/search?hl=en&lr=&q=%22directory+listings+of%22+%2B+inurl%3A"..filetype.."+%2B+%22"..searchstring.."%22&btnG=Search\n".."5. (this won't usually work very well for multimedia files, but works great for other file types)\n".."http://www.google.com/search?hl=en&lr=&q=filetype%3A"..filetype.."+%2B+%22"..searchstring.."%22&btnG=Search\n".."\nIf none of these searches return the desired results, try to refine your search";
MsgPm(nick, message);
end
if (string.find(data, set_cmd_help)) then
-- User asked for help, add help-message for bot.
MsgHelp(nick);
end;

return 1;
end


-- Show help-message to user.
function MsgHelp (user)
-- Define local variables, for later use.
local help;
-- Build help-message.
help = "The following "..set_bot_name.." commands are available to you:\n"..
"\n"..set_cmd_help.." - This help file\n\n"..
"#google <file type> <keywords> - this command will generate a list of four URL's for you, from Google.\n\n"..
"For example, let's say you were looking for MP3's from Radiohead. In that case, your command would\n"..
"look like this:\n\n"..
"\t#google mp3 radiohead\n\n"..
"If you want to use more than one keyword, separate them with a + such as in this example:\n\n"..
"\t#google avi star+wars\n\n"..
"The resulting URLS will look for AVI files with the words Star and Wars in the file name.";

-- Send help message to user, and return successfully.
MsgPm(user, help);
return 1;
end;

-- Sends private messages to specified user.
function MsgPm(user, data)
return SendToUser(user, "$To: "..user.." From: "..set_bot_name.." $<"..set_bot_name.."> "..data.."|");
end; 
