--// hubtopic.lua
--// A script for LamaHub Commands: !topic, !showtopic (!/+)
--// Szabolcs Molnar, 2006; rev 002/20060908
--// Ported by ZeXx86 in 6.4.2007

hubtopic = {}
hubtopic.isitset = false
hubtopic.topic = ""


function hubtopic.deleteTopic(nick)
	local hubname = ConfigGet("hubname")

	SendToAll("$HubName " .. hubname .. "|")
	BotToAll(nick .. " has deleted the topic")

	hubtopic.topic = ""
	hubtopic.isitset = false

	return 1
end

function hubtopic.setTopic(nick, topic)
	local hubname = ConfigGet("hubname")

	SendToAll("$HubName " .. hubname .. " - " .. topic .. "|")
	BotToAll(nick .. " has changed topic to: " .. topic)

	hubtopic.isitset = true
	hubtopic.topic = topic

	return 1
end

function hubtopic.sendTopic(nick)
	if hubtopic.isitset then
		local hubname = ConfigGet("hubname")
		SendToUser(nick, "$HubName "..hubname.." - "..hubtopic.topic.."|")
	end
	return 1
end

function hubtopic.getTopic()
	if hubtopic.isitset then
		return "Current topic is: " .. hubtopic.topic
	else
		return "No topic set."
	end
end

function hubtopic.announce(nick, allCases, sendToAll)
	local ret = ""
	if hubtopic.isitset then
		local topic = hubtopic.topic
		if not sendToAll then
			BotToUser(nick, "Current topic is: " .. topic)
		else
			BotToAll("Current topic is: " .. topic)
		end
	elseif allCases then
		if not sendToAll then
			BotToUser(nick, "No topic set.")
		else
			BotToAll("No topic set.")
		end
	end
	return 1
end

function EventUserConnected (nick, myinfo)
	hubtopic.sendTopic(nick)
	hubtopic.announce(nick)
end

function EventCmdtopic(nick, parameters)

	local len = string.len (parameters)
	io.write ("delka: "..len.."\n")
	if (len > 1) then
		hubtopic.setTopic(nick, parameters)
		BotToUser (nick, "Topic set.")
		return 1
	else
		hubtopic.deleteTopic(nick)
		BotToUser (nick, "Topic deleted.")
		return 1
	end
end

function EventCmdshowtopic (nick, data)
	BotToUser (nick, hubtopic.getTopic())
	return 1
end

CommandAdd("topic", "Set up or deletes hub topic", 3)
CommandAdd("showtopic", "Shows hub topic", 0)
