---------------------------------------------------------------------
-- IP - Ranger for LamaHub / By: NightLitch
-- Modify by: ZeXx86
-- email: zexx86@gmail.com
-- Ported to LamaHub lua syntax
---------------------------------------------------------------------


-- bot name
sBotName = "IP-Sec"
sBotDescription = "IP-Security bot"
sBotMail = "zexx86@gmail.com"

-- add bot
BotAdd (sBotName, sBotDescription, "BOT", sBotMail, 4, 0)

-- Range Table
aRange = {
-- Add ALLOWED ranges here...
["127.0.0.1-127.0.0.255"] = 1,
["10.1.1.1-10.1.1.255"] = 1,
["192.186.0.1-192.168.0.255"] = 1,
-- End of Table
}

---------------------------------------------------------------------
-- Don't Edit --
---------------------------------------------------------------------
-- Functions

Func = {}

Func.ComIP = function(curIP)
local _,_,a,b,c,d = string.find(curIP, "(%d+).(%d+).(%d+).(%d+)")
return a*16777216 + b*65536 + c*256 + d
end

Func.CheckIP = function(curIP)
local _,_,a,b,c,d = string.find(curIP, "(%d*).(%d*).(%d*).(%d*)")
if ( tonumber(a) and tonumber(b) and tonumber(c) and tonumber(d) ) then
local UserIP = Func.ComIP(curIP)
if UserIP then
 for Range, Table in aRange do
  local _,_,R1,R2 = string.find(Range, "(%S+)-(%S+)")
  Range1 = Func.ComIP(R1)
  Range2 = Func.ComIP(R2)
  if UserIP >= Range1 and UserIP <= Range2 then
   return 1,Range
  end
 end
end
end
return 0
end

---------------------------------------------------------------------
-- Verlihub UserConnected Starts Here --
---------------------------------------------------------------------

function EventNewClient(sNick)
local ip = GetIP (sNick)
local Allow,Range  = Func.CheckIP (ip)

---------------------------------------------------------------------
-- Welcome/Kick Message --
---------------------------------------------------------------------
if Allow == 1 then
  SendToUser (sNick, "<"..sBotName.."> Your IP address '"..ip.."' was granted.|")
 else
  SendToUser (sNick, "<"..sBotName.."> Your IP address '"..ip.."' was denied.\n*** Forbidden ***|")
  BanIP (ip, "360")
 end

return 1

end

---------------------------------------------------------------------
-- Users IP --
---------------------------------------------------------------------
function GetIP(sNick)
 ip = UserIP (sNick)
 return ip
end 
