/*
 *  (C) Copyright 2006 ZeXx86 (Admin@Infern0.tk)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */
 

#ifndef _PLUGIN_H
#define _PLUGIN_H

#include "utils.h"
#include "proto.h"

/* Plugin structure */
//typedef int (plugin_handler_t) ();

typedef struct plugin_ctx {
  struct plugin_ctx *next, *prev;

  char name[64];
  void *handle;
  int event_handler_e;
  int (*event_handler) (char *nick, char *txt, int state, unsigned len);
} plugin_t;


/*typedef struct plugin_user {
  char nick[DEFAULT_MAX_NICKLENGTH];
  char ip[15];
  short state;
  unsigned SOCKET socket;
  unsigned long long share;
  int online;
  unsigned short iclass;
  unsigned short slots;
  char mode;
  unsigned long supports;

  void *privated;
} plugin_user_t;

typedef struct plugin_private plugin_private_t;

struct plugin_private {
  struct plugin_private *next, *prev;

  plugin_user_t user;		// plugin user data. filled at user creation. a bit wastefull, but it prevents exporting the user_t 
//  plugin_event_handler_t *handler;	// for robots.
  unsigned long num;		// number of private pointers
  user_t *parent;
  proto_t *proto;

  void **store;			// private pointers for all modules
};
*/

extern void event_plugin (user_t *u, char *data, int state, unsigned len);
extern int plugin_botadd (char *nick, char *desc, char *conn, char *mail, 
				unsigned short iclass, unsigned long long share);
extern short plugin_userclass (char *nick);
extern char *plugin_userip (char *nick);
extern int plugin_sendtouser (char *nick, char *txt);
extern int plugin_bottouser (char *nick, char *txt);
extern int plugin_pmtouser (char *target, char *nick, char *txt);
extern int plugin_bannick (char *nick, char *time);
extern int plugin_banip (char *ip, char *time);
extern int plugin_banperm (char *ip);
extern int plugin_bandel (char *val);
extern int plugin_kick (char *nick);
extern int plugin_chatlock ();
extern int plugin_pmlock ();
extern unsigned long long plugin_uptime ();
extern int plugin_save ();

extern user_t *plugin_user_next ();
extern int init_plugin ();

#endif
