/*
 *  (C) Copyright 2006 ZeXx86 (Admin@Infern0.tk)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */


#ifndef _PROTO_H
#define _PROTO_H

#include "user.h"
#include "commands.h"

/* 		Supports of user's clients				 */
#define NMDC_SUPPORTS_NoGetINFO       1	/* no need for GetINFOs */
#define NMDC_SUPPORTS_NoHello         2	/* no $Hello for new signons */
#define NMDC_SUPPORTS_UserCommand     4	/* */
#define NMDC_SUPPORTS_UserIP2	      8	/* */
#define NMDC_SUPPORTS_QuickList      16	/* NOT SUPPORTED ! deprecated. */
#define NMDC_SUPPORTS_TTHSearch      32	/* client can handle TTH searches */

#define NMDC_SUPPORTS_ZPipe	   1024 /* */
#define NMDC_SUPPORTS_ZLine	   2048	/* */

/*			NMDC Tokens			*/
#define   TOKEN_VALIDATENICK			"alidateNick"
#define   TOKEN_MYINFO				"$MyINFO"
#define	  TOKEN_GETINFO				"$GetINFO"
#define   TOKEN_GETNICKLIST			"$GetNickList"
#define	  TOKEN_CONNECTTOME			"$ConnectToMe"
#define	  TOKEN_REVCONNECTTOME			"$RevConnectToMe"
#define	  TOKEN_SEARCH				"$Search"
#define	  TOKEN_OPFORCEMOVE			"$OpForceMove"
#define	  TOKEN_TO				"$To:"
#define	  TOKEN_KEY				"$Key"
#define	  TOKEN_QUIT				"$Quit"
#define	  TOKEN_MYPASS				"$MyPass"
#define   TOKEN_BOTINFO				"$BotINFO"
#define	  TOKEN_SUPPORTS			"$Supports"
#define	  TOKEN_CHAT				'<'

/*		 Protocol states		*/
#define   PROTO_STATE_OUT			-1
#define   PROTO_STATE_INIT			0
#define   PROTO_STATE_SENDLOCK			1
#define   PROTO_STATE_WAITNICK			2
#define   PROTO_STATE_WAITPASS			3
#define   PROTO_STATE_HELLO			4
#define   PROTO_STATE_ONLINE			5
#define   PROTO_STATE_DISCONNECTED		6

typedef struct {
	int (*sendtoall) (char *txt);
	int (*sendtoall_len) (char *txt, unsigned long len);
	int (*sendtouser) (char *nick, char *txt);
	int (*sendtouser_len) (user_t *u, char *txt, unsigned long len);
	int (*sendtosocket) (int id, char *txt);
	
	int (*bottouser) (char *nick, char *txt);
	int (*bottoall) (char *txt);
	int (*pmtouser) (char *target, char *nick, char *txt);

	char *(*configget) (char *name);
	int (*configset) (char *name, char *value);
	int (*configreg) (char *name, char *desc, int type, char *value);

	int (*bannick) (char *nick, char *time);
	int (*banip) (char *ip, char *time);
	int (*banperm) (char *ip);
	int (*bandel) (char *val);
	int (*kick) (char *nick);

	int (*chatlock) ();
	int (*pmlock) ();

	unsigned long long (*uptime) ();

	int (*forcemove) (user_t *u, char *destination);

	int (*commandadd) (char *name, char *desc, command_handler_t *handler ,unsigned int iclass);
	int (*commanddel) (char *name);

	char *(*userip) (char *nick);
	short (*userclass) (char *nick);

	int (*botadd) (char *nick, char *desc, char *conn, char *mail, unsigned short iclass, unsigned long long share);

	char *name;
} proto_t;

extern int proto_nmdc_user_redirect (user_t *u);
extern int proto_nmdc_user_forcemove (user_t *u, char *destination);
extern int proto_nmdc_state_disconnect (user_t *user);
extern int proto_flush_cache ();
extern int proto_state_handler (user_t *u, char *data, unsigned int len);

#endif 
 
