/*
 *  (C) Copyright 2006 ZeXx86 (zexx86@gmail.com)
 *  (C) Copyright 2009 ZeXx86 (zexx86@gmail.com)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */


#ifdef __WIN32__
 #include <windows.h>
#else
 #ifndef __zexos__
 #ifndef __android__
  #include <crypt.h>
 #endif
 #endif
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "config.h"
#include "proto.h"
#include "utils.h"
#include "user.h"

extern user_t user_list;
extern account_t accounts_list;
extern config_t config;

char file[64];

int account_find (char *nick);

/********************************************************************/

int account_add (user_t *u, char *pass, int iclass)
{
	if (account_find (u->nick) > 0)
		return 0;

	account_t *a;
	
	// alloc and init context
	a = (account_t*) malloc (sizeof (account_t));
	
	strcpy (a->nick, u->nick);
	strcpy (a->pass, crypt (pass, HUBSOFT));

	a->iclass = iclass;

	// write to file
	int i = 1;
        char str[10240], str2[1024];
	strcpy (str, "regnum ");

	account_t *c;
	
	/* old accounts */
	for (c = accounts_list.next; c != &accounts_list; c = c->next) {
		strcpy (str2, c->nick); strcat (str2, " "); strcat (str2, c->pass); strcat (str2, " ");
		char cclass[3]; sprintf (cclass, "%d", c->iclass); strcat (str2, cclass);
		strcat (str2, "\n");

		i ++;
	}

	/* new account */
    	strcat (str2, u->nick); strcat (str2, " "); strcat (str2, a->pass); strcat (str2, " ");
	char cclass[10]; sprintf (cclass, "%d", iclass); strcat (str2, cclass);
	strcat (str2, "\n");
	
	char num[16]; sprintf (num, "%d\n", i);

	strcat (str, num);

	char rights[128];
	sprintf (rights, "%llu %llu %llu %llu %llu %llu\n", config.rights[0], config.rights[1],
			config.rights[2], config.rights[3], config.rights[4],
					config.rights[5]);
	strcat (str, rights);

	strcat (str, str2);

	FILE *freglist;
	freglist=fopen (file, "w");
	fputs (str, freglist);
	fclose (freglist);

	// add into list
	a->next = &accounts_list;
	a->prev = accounts_list.prev;
	a->prev->next = a;
	a->next->prev = a;

	return 1;
}

int account_del (user_t *op, char *nick)
{	
	int a = account_find (nick);
	if (a == 0)
		return 0;

	if (a > op->iclass)
		return 0;

        char str[10240], str2[1024];
	int i = 0;
	strcpy (str, "regnum ");

	/* new account list */
	account_t *c;
	for (c = accounts_list.next; c != &accounts_list; c = c->next) {
		if (!strcmp (c->nick, nick)) {
			c->next->prev = c->prev;
			c->prev->next = c->next;
		} else {
			strcat (str2, c->nick); strcat (str2, " "); strcat (str2, c->pass); strcat (str2, " ");
			char cclass[3]; sprintf (cclass, "%d", c->iclass); strcat (str2, cclass);  
			strcat (str2, "\n");

			i ++;
		}
	}

	char num[5]; sprintf (num, "%d\n", i);

	strcat (str, num);

	char rights[80];
	sprintf (rights, "%llu %llu %llu %llu %llu %llu\n", config.rights[0], config.rights[1],
			config.rights[2], config.rights[3], config.rights[4],
					config.rights[5]);
	strcat (str, rights);

	strcat (str, str2);

	FILE *freglist;
	freglist=fopen (file, "w");					
	fputs (str, freglist);
	fclose (freglist);

	return 1;
}

int account_find (char *nick)
{
	account_t *a;

	for (a = accounts_list.next; a != &accounts_list; a = a->next) {
    	    if (!strcmp (nick, a->nick))
		return a->iclass;
	}

	return 0;
}

int account_class (char *nick, short iclass)
{
	account_t *a;

	if (iclass < 0 || iclass > 5)
		return -1;

	for (a = accounts_list.next; a != &accounts_list; a = a->next) {
    	    if (!strcmp (nick, a->nick)) {
		a->iclass = iclass;	// change class in memory

		// change class in account file
		account_t *b;
		int regs = 0;
	
		char str2[10240], str[512];
		strcpy (str, "regnum ");
	
		for (b = accounts_list.next; b != &accounts_list; b = b->next) {
			regs ++;
		
			strcat (str2, b->nick); strcat (str2, " "); strcat (str2, b->pass); strcat (str2, " ");
			char iclass[5];
			sprintf (iclass, "%d\n", b->iclass);
			strcat (str2, iclass);
		}
		
		char num[5]; sprintf (num, "%d\n", regs);
	
		strcat (str, num);
	
		char rights[80];
		sprintf (rights, "%llu %llu %llu %llu %llu %llu\n", config.rights[0], config.rights[1],
				config.rights[2], config.rights[3], config.rights[4],
						config.rights[5]);
		strcat (str, rights);
	
		strcat (str, str2);
	
		FILE *freglist;
		freglist = fopen (file, "w");
		fputs (str, freglist);
		fclose (freglist);

		return 1;
	    }
	}

	return 0;
}

int account_check (user_t *u, char *pass)
{
	account_t *a;
	int i = 0;
	char *pwd = strdup (crypt (pass, HUBSOFT));

	for (a = accounts_list.next; a != &accounts_list; a = a->next) {
    	    if (!strcmp (u->nick, a->nick)) {
		i ++;

		if (!strcmp (pwd, a->pass)) {
			free (pwd);
			return 1;
		}
	    }	
	}
	
	free (pwd);

	if (i == 0)
		return -1;


	return 0;
}

int account_passwd (user_t *u, char *pass)
{
	account_t *a;
	int i = 0, regs = 0;;

        char str2[10240], str[1024];
	strcpy (str, "regnum ");

	for (a = accounts_list.next; a != &accounts_list; a = a->next) {
		regs ++;

		if (!strcmp (u->nick, a->nick)) {
			a->pass[0] = '\0';

			sprintf (a->pass, crypt (pass, HUBSOFT));

			i ++;
		}

		strcat (str2, a->nick); strcat (str2, " "); strcat (str2, a->pass); strcat (str2, " ");
		char iclass[5];
		sprintf (iclass, "%d\n", a->iclass);
		strcat (str2, iclass);
	}
	
	if (i == 0)
		return 0;
	
	char num[5]; sprintf (num, "%d\n", regs);

	strcat (str, num);

	char rights[80];
	sprintf (rights, "%llu %llu %llu %llu %llu %llu\n", config.rights[0], config.rights[1],
			config.rights[2], config.rights[3], config.rights[4],
					config.rights[5]);
	strcat (str, rights);

	strcat (str, str2);

	FILE *freglist;
	freglist=fopen (file, "w");
	fputs (str, freglist);
	fclose (freglist);

	return 1;
}

void readstr (FILE *f,char *string)
{
	do {
		fgets (string, 255, f);
	} while ((string[0] == '/') || (string[0] == '\n'));
}


int account_load ()
{
	FILE *filein;
	char oneline[255];
	int regnum;
	char Name[40],Pass[40];

	filein = fopen (file, "rt");

	if (!filein)
		return 0;

	// parse count of all created accounts
	readstr(filein,oneline);
	sscanf(oneline, "regnum %d\n", &regnum);

	// parse rights for all class
	readstr(filein,oneline);
	sscanf(oneline, "%llu %llu %llu %llu %llu %llu\n", &config.rights[0], &config.rights[1],
			&config.rights[2], &config.rights[3], &config.rights[4],
					&config.rights[5]);

	int loop;
	for (loop = 0; loop < regnum; loop ++) {
		int Class = 1;
		readstr (filein,oneline);
		sscanf (oneline, "%s %s %d", Name, Pass, &Class);
		
		account_t *a;
		
		// alloc and init context
		a = (account_t *) malloc (sizeof (account_t));
		
		strcpy (a->nick, Name);
		strcpy (a->pass, Pass);
		a->iclass = Class;
	
		// add into list
		a->next = &accounts_list;
		a->prev = accounts_list.prev;
		a->prev->next = a;
		a->next->prev = a;

	}

	fclose (filein);	

	return 1;
}

int init_accounts ()
{
	user_list.next = &user_list;
	user_list.prev = &user_list;

	// set default user values
	strcpy (user_list.nick, " ");
	user_list.socket = 0;
	user_list.share = 0;
	user_list.online = false;
	user_list.iclass = 0;

	accounts_list.next = &accounts_list;
	accounts_list.prev = &accounts_list;

	sprintf (file, "./%s", DEFAULT_ACCOUNTSFILE);

	int r = account_load ();
	
	if (!r)	{
		printf ("> WARNING -> Account's file '%s' not found. Pls create owner account with:\n\t./server ownernick ownerpasswd\n", DEFAULT_ACCOUNTSFILE);

		return 0;
	}

	return 1;
}


/* 
 * 	USER WORK
 */

user_t *user_findbynick (char *nick)
{
	user_t *user;
	for (user = user_list.next; user != &user_list; user = user->next) {
		if (user->state == PROTO_STATE_ONLINE)
			if (!strcmp (nick, user->nick))
				return user;
	}

	return NULL;
}

user_t *user_findbyip (char *ip)
{
	user_t *user;
	for (user = user_list.next; user != &user_list; user = user->next) {
		if (!strcmp (ip, user->ip))
			return user;
	}

	return NULL;
}
