/*
 *  (C) Copyright 2006 ZeXx86 (zexx86@zexos.org)
 *  (C) Copyright 2010 ZeXx86 (zexx86@zexos.org)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */


#ifndef _USER_H
#define _USER_H

#ifdef __WIN32__
 #include <windows.h>
#endif
#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include "defaults.h"

/* User structure */
typedef struct user_context {
  struct user_context *next, *prev;

  char nick[DEFAULT_MAX_NICKLENGTH];
  char ip[17];
  short state;
  unsigned int socket;
  char myinfo[DEFAULT_MAX_MYINFOLENGTH];
  unsigned long long share;
  bool online;
  unsigned char iclass;
  unsigned short slots;
  char mode;
  unsigned long flag;
  long long int searchlast;
  char *buf;
  unsigned long buf_used;
  unsigned long buf_len;
  unsigned long buf_offset;
  unsigned short myinfo_len;
  unsigned short nick_len;
#ifdef POLL
  unsigned int fd;
#endif
} user_t;

/* Accounts structure */
typedef struct account_context {
  struct account_context *next, *prev;

  char nick[DEFAULT_MAX_NICKLENGTH];
  char pass[64];
  int  iclass;
} account_t;


extern int account_add (user_t *u, char *pass, int iclass);
extern int account_del (user_t *op, char *nick);
extern int account_find (char *nick);
extern int account_class (char *nick, short iclass);
extern int account_check (user_t *u, char *pass);
extern int account_passwd (user_t *u, char *pass);
extern int init_accounts ();
extern user_t *user_findbynick (char *nick);
extern user_t *user_findbyip (char *ip);

#endif 
