/*
 *  (C) Copyright 2006 ZeXx86 (Admin@Infern0.tk)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */


#ifndef _RIGHTS_H
#define _RIGHTS_H

#ifdef __WIN32__
 #include <windows.h>
#endif
#include <stdio.h>
#include <string.h>
#include "defaults.h"


/* --------- RIGHTS ---------- */

#define CAP_SHARE  	   0x0001LL
#define CAP_KICK   	   0x0002LL
#define CAP_BAN    	   0x0004LL
#define CAP_KEY    	   0x0008LL
#define CAP_CONFIG 	   0x0010LL
#define CAP_SAY    	   0x0020LL
#define CAP_USER   	   0x0040LL
#define CAP_CHAT   	   0x0200LL
#define CAP_PM     	   0x0400LL
#define CAP_DL	   	   0x0800LL
#define CAP_SEARCH	   0x2000LL
#define CAP_REDIRECT	   0x4000LL
#define CAP_TAG		   0x8000LL
#define CAP_SHAREHIDE	  0x10000LL
#define CAP_SHAREBLOCK	  0x20000LL
#define CAP_SPAM	  0x40000LL
#define CAP_NOSRCHLIMIT   0x80000LL
#define CAP_HIDDEN	 0x800000LL


/* shortcuts... */
#define CAP_GUEST (CAP_CHAT | CAP_DL | CAP_SEARCH | CAP_TAG)
#define CAP_REG   (CAP_GUEST | CAP_PM)
#define CAP_VIP   (CAP_REG | CAP_SHARE | CAP_SPAM)
#define CAP_OP    (CAP_VIP | CAP_BAN | CAP_KEY)
#define CAP_ADMIN (CAP_OP | CAP_USER | CAP_REDIRECT)
#define CAP_OWNER (CAP_ADMIN | CAP_CONFIG)


/* User flags */
#define	USER_FLAG_GAG		64
/* ---------- */

typedef struct flag {
  unsigned long long flag;
  char *name;
  char *description;
} flag_t;


extern flag_t class_rights[];

extern int class_right_add (unsigned short iclass, unsigned long long flag);
extern int class_right_check (user_t *u, unsigned long long flag);
extern int user_flag_add (user_t *u, unsigned long flag);
extern int user_flag_del (user_t *u, unsigned long flag);
extern int user_flag_check (user_t *u, unsigned long flag);
extern int init_rights ();

#endif

