/*
 *  (C) Copyright 2006 ZeXx86 (Admin@Infern0.tk)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */


#ifndef _UTILS_H
#define _UTILS_H

#include "user.h"
#include "ban.h"
#include "defaults.h"

#define MAX_REDIRECTHOST 10

typedef struct
{
	long int	num_chats;
	long int	num_commands;
	long int	num_forcemove;
	long int	num_kick;
	long int 	num_ban;
	long int	num_drop;
	long int	num_pm;
	long int	num_connect;
	long int     	num_search;
	     int     	currusers;
	long int	botinfo;

	long int     	cache_zpipers;
	    short	redirect_hosts;	

	float        	buf_zpipe_compression;
	double		buf_zpipe_compression_avg;
	long int	buf_zpipe_count;
	unsigned int 	def_mainchat;

	unsigned long long traffic_tx;
	unsigned long long traffic_rx;
}stats_t;

/* next generation of strings :-) */
typedef struct bf_buffer_context {
  //struct bf_buffer_context *next, *prev;

	char *s;
	unsigned long l;
} bf_buffer;


extern int send_to_socket (int id, char *txt);
extern int send_to_user (user_t *u, char *txt);
extern int send_to_user_len (user_t *u, char *txt, unsigned long len);
extern int send_to_user_len_direct (user_t *u, char *txt, unsigned long len);
extern int send_to_all (char *txt);
extern int send_to_all_len (char *txt, unsigned long len);
extern int bot_to_user (user_t *u, char *txt);
extern int bot_to_user_len (user_t *u, char *txt, unsigned l);
extern int bot_to_all (char *txt);
extern int pm_to_user (user_t *target, char *nick, char *txt);
extern int socket_buf (user_t *u);

extern int parse_token (user_t *u, char *data, unsigned long int len);

extern int set_motd (char *data);
extern int get_motd ();

#ifdef __WIN32__ // win32 missing crypt ()
extern char *crypt (char *data, char *hash);
#endif

extern char *share_tostring (unsigned long long size);
extern char *time_tostring (unsigned long s);

extern char *strarg (short m, char *data, unsigned long int len);

extern unsigned int bf_printf (bf_buffer *buf, char *data, unsigned long len);
extern unsigned int bf_strncat (bf_buffer *buf, char *data, unsigned long len);
extern unsigned int bf_strncat_alloc (bf_buffer *buf, char *data, unsigned long len);
extern unsigned int bf_alloc (bf_buffer *buf, unsigned long len);
extern unsigned int bf_free (bf_buffer *buf);

extern void sprintfa(char *buf, const char *format, ...);

extern void cache_rebuild ();

#ifdef POLL
extern unsigned int p;
#endif

#endif 
 
